Add solutions for problems 97 and 99 in C
This commit is contained in:
parent
899be1ccf5
commit
3836e41c75
1000
C/base_exp.txt
Normal file
1000
C/base_exp.txt
Normal file
File diff suppressed because it is too large
Load Diff
48
C/p097.c
Normal file
48
C/p097.c
Normal file
@ -0,0 +1,48 @@
|
||||
/* The first known prime found to exceed one million digits was discovered in 1999, and is a Mersenne prime of the form 26972593−1;
|
||||
* it contains exactly 2,098,960 digits. Subsequently other Mersenne primes, of the form 2p−1, have been found which contain more digits.
|
||||
*
|
||||
* However, in 2004 there was found a massive non-Mersenne prime which contains 2,357,207 digits: 28433×2^7830457+1.
|
||||
*
|
||||
* Find the last ten digits of this prime number.*/
|
||||
|
||||
#include <stdio.h>
|
||||
#include <stdlib.h>
|
||||
#include <time.h>
|
||||
|
||||
int main(int argc, char **argv)
|
||||
{
|
||||
int b = 2, e = 7830457, e_first;
|
||||
long int m = 10000000000, c, result;
|
||||
double elapsed;
|
||||
struct timespec start, end;
|
||||
|
||||
clock_gettime(CLOCK_MONOTONIC, &start);
|
||||
|
||||
/* Using modular exponentiation algorithm to calculate 2^7830457. The algorithm is:
|
||||
* Set c=1, e'=0
|
||||
* Increment e' by 1
|
||||
* Set c=b*c%m, where b is the base (2) and m is the modulo (10000000000 since
|
||||
* we want the last 10 digits.
|
||||
* If e'<e (where e is the exponent), repeat step 3, otherwise c contains the result.*/
|
||||
c = 1;
|
||||
e_first = 0;
|
||||
|
||||
while(e_first < e)
|
||||
{
|
||||
e_first++;
|
||||
c = (b * c) % m;
|
||||
}
|
||||
|
||||
result = (c * 28433 + 1) % m;
|
||||
|
||||
clock_gettime(CLOCK_MONOTONIC, &end);
|
||||
|
||||
elapsed = (end.tv_sec - start.tv_sec) + (double)(end.tv_nsec - start.tv_nsec) / 1000000000;
|
||||
|
||||
printf("Project Euler, Problem 97\n");
|
||||
printf("Answer: %ld\n", result);
|
||||
|
||||
printf("Elapsed time: %.9lf seconds\n", elapsed);
|
||||
|
||||
return 0;
|
||||
}
|
60
C/p099.c
Normal file
60
C/p099.c
Normal file
@ -0,0 +1,60 @@
|
||||
/* Comparing two numbers written in index form like 2^11 and 3^7 is not difficult, as any calculator would confirm that
|
||||
* 2^11 = 2048 < 3^7 = 2187.
|
||||
*
|
||||
* However, confirming that 632382^518061 > 519432^525806 would be much more difficult, as both numbers contain over three million digits.
|
||||
*
|
||||
* Using base_exp.txt, a 22K text file containing one thousand lines with a base/exponent pair on each line,
|
||||
* determine which line number has the greatest numerical value.
|
||||
*
|
||||
* NOTE: The first two lines in the file represent the numbers in the example given above.*/
|
||||
|
||||
#include <stdio.h>
|
||||
#include <stdlib.h>
|
||||
#include <math.h>
|
||||
#include <time.h>
|
||||
|
||||
int main(int argc, char **argv)
|
||||
{
|
||||
int i, max_i = -1, base, exp;
|
||||
double curr, max = 0, elapsed;
|
||||
struct timespec start, end;
|
||||
FILE *fp;
|
||||
|
||||
clock_gettime(CLOCK_MONOTONIC, &start);
|
||||
|
||||
if((fp = fopen("base_exp.txt", "r")) == NULL)
|
||||
{
|
||||
fprintf(stderr, "Error while opening file %s\n", "base_exp.txt");
|
||||
return 1;
|
||||
}
|
||||
|
||||
for(i = 1; i <= 1000; i++)
|
||||
{
|
||||
fscanf(fp, "%d,%d", &base, &exp);
|
||||
/* If
|
||||
* a^x > b^y
|
||||
* log(a^x) > log(b^y)
|
||||
* x*log(a) > y*log(b).
|
||||
* So for each b^e, calculate e*log(b) and compare these numbers instead.*/
|
||||
curr = exp * log(base);
|
||||
|
||||
if(curr > max)
|
||||
{
|
||||
max = curr;
|
||||
max_i = i;
|
||||
}
|
||||
}
|
||||
|
||||
fclose(fp);
|
||||
|
||||
clock_gettime(CLOCK_MONOTONIC, &end);
|
||||
|
||||
elapsed = (end.tv_sec - start.tv_sec) + (double)(end.tv_nsec - start.tv_nsec) / 1000000000;
|
||||
|
||||
printf("Project Euler, Problem 99\n");
|
||||
printf("Answer: %d\n", max_i);
|
||||
|
||||
printf("Elapsed time: %.9lf seconds\n", elapsed);
|
||||
|
||||
return 0;
|
||||
}
|
Loading…
x
Reference in New Issue
Block a user